import * as i0 from '@angular/core';
import { NgModule } from '@angular/core';
import { generateAlias } from '@devs-studio/string';

class DevsValidatorsModule {
}
DevsValidatorsModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.3.0", ngImport: i0, type: DevsValidatorsModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
DevsValidatorsModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "14.3.0", ngImport: i0, type: DevsValidatorsModule });
DevsValidatorsModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "14.3.0", ngImport: i0, type: DevsValidatorsModule });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.3.0", ngImport: i0, type: DevsValidatorsModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [],
                    imports: [],
                    exports: []
                }]
        }] });

function _checkDuplicates(inputs, fields, alias) {
    var items = inputs.reduce((acc, cur) => {
        var parts = [];
        for (let field of fields) {
            if (alias) {
                parts.push(generateAlias(cur[field]));
            }
            else {
                parts.push(cur[field]);
            }
        }
        acc.push(parts.join('|'));
        return acc;
    }, []);
    var uniques = items.filter((value, index, self) => {
        return self.indexOf(value) === index;
    });
    return items.length === uniques.length;
}
function checkArrayUnique(fields, alias) {
    return (control) => {
        const items = control.value;
        if (!_checkDuplicates(items, fields, alias)) {
            return { unique: { value: control.value } };
        }
        return null;
    };
}

function _baseFunction(right, rule, callback) {
    return (control) => {
        const leftValue = Number(control.value);
        const formGroup = control.parent;
        if (formGroup) {
            const rightValue = Number(formGroup.get(right)?.value);
            if (!Number.isNaN(leftValue) && !Number.isNaN(rightValue) && !callback(leftValue, rightValue)) {
                return { [rule]: true };
            }
        }
        return null;
    };
}
function isGreaterThanOrEqual(right) {
    return _baseFunction(right, 'greaterThanOrEqual', (left, right) => {
        return left >= right;
    });
}
function isLessThanOrEqual(right) {
    return _baseFunction(right, 'lessThanOrEqual', (left, right) => {
        return left <= right;
    });
}

class DevsValidators {
    static checkArrayUnique(fields, alias) {
        return checkArrayUnique(fields, alias);
    }
    static isGreaterThanOrEqual(right) {
        return isGreaterThanOrEqual(right);
    }
    static isLessThanOrEqual(right) {
        return isLessThanOrEqual(right);
    }
}

/*
 * Public API Surface of validators
 */

/**
 * Generated bundle index. Do not edit.
 */

export { DevsValidators, DevsValidatorsModule };
//# sourceMappingURL=devs-studio-angular-validators.mjs.map
